use crate::prelude::*;
use library_loader::load_function_ptrs;

use std::os::raw::c_void;

pub type PFN_vkDebugUtilsMessengerCallbackEXT = extern "system" fn(
    VkDebugUtilsMessageSeverityFlagsEXT,
    VkDebugUtilsMessageTypeFlagsEXT,
    *const VkDebugUtilsMessengerCallbackDataEXT,
    *mut c_void,
) -> VkBool32;

load_function_ptrs!(DebugUtilsMessengerFunctions, {
    vkCreateDebugUtilsMessengerEXT(
        instance: VkInstance,
        createInfo: *const VkDebugUtilsMessengerCreateInfoEXT,
        allocationCallbacks: *const VkAllocationCallbacks,
        debugUtilsMessenger: *mut VkDebugUtilsMessengerEXT
    ) -> VkResult,

    vkDestroyDebugUtilsMessengerEXT(
        instance: VkInstance,
        debugUtilsMessenger: VkDebugUtilsMessengerEXT,
        allocationCallbacks: *const VkAllocationCallbacks
    ) -> (),
});

impl DebugUtilsMessengerFunctions {
    pub fn new(
        static_functions: &StaticFunctions,
        instance: VkInstance,
    ) -> DebugUtilsMessengerFunctions {
        DebugUtilsMessengerFunctions::load(|name| unsafe {
            static_functions.vkGetInstanceProcAddr(instance, name.as_ptr())
                as *const std::ffi::c_void
        })
    }
}
